﻿using System;
using System.Collections.ObjectModel;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace TransitionControlsUserControls
{
    public class ViewModel: ViewModelBase
    {
        public ObservableCollection<SitePage> SitePages { get; set; }

        private ICommand selectPreviousPage;
        private ICommand selectNextPage;
        private SitePage _selectedPage;

        public SitePage SelectedPage
        {
            get { return this._selectedPage; }
            set
            {
                if (this._selectedPage != value)
                {
                    this._selectedPage = value;
                    this.OnPropertyChanged(() => this.SelectedPage);
                }
            }
        }

        public ICommand SelectNextPage
        {
            get
            {
                return this.selectNextPage;
            }
        }

        public ICommand SelectPreviousPage
        {
            get
            {
                return this.selectPreviousPage;
            }
        }

        public void SelectNextPageAction(object param)
        {
            int index = this.SitePages.IndexOf(this.SelectedPage) + 1;
            if (index >= this.SitePages.Count)
            {
                this.SelectedPage = this.SitePages[0];
            }
            else
            {
                this.SelectedPage = this.SitePages[index];
            }
        }

        public void SelectPrevPageAction(object param)
        {
            int index = this.SitePages.IndexOf(this.SelectedPage) - 1;
            if (index < 0)
            {
                this.SelectedPage = this.SitePages[this.SitePages.Count - 1];
            }
            else
            {
                this.SelectedPage = this.SitePages[index];
            }
        }

        public ViewModel()
        {
            this.SitePages = new ObservableCollection<SitePage>()
            {
                new SitePage() { DisplayName="Page1", PageUri="/Page1.xaml" },
                new SitePage() { DisplayName="Page2", PageUri="/Page2.xaml" },
                new SitePage() { DisplayName="Page3", PageUri="/Page3.xaml" }
            };

            this.SelectedPage = SitePages[0];
            this.selectPreviousPage = new DelegateCommand(this.SelectPrevPageAction);
            this.selectNextPage = new DelegateCommand(this.SelectNextPageAction);
        }
    }
}
